﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">

protected void Page_Load(object sender, System.EventArgs e) 
{ 
    
    if (Request.Form["SageTable"] != null) { 
        
        OleDbConnectionStringBuilder ConStrBuilder = new OleDbConnectionStringBuilder(); 
        ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0"; 
        ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb"); 
        ConStrBuilder.PersistSecurityInfo = false; 
        
        OleDbConnection Conn = new OleDbConnection(ConStrBuilder.ConnectionString); 
        Conn.Open();

        OleDbCommand Cmd;
        
        switch (Request.Form["SageTable"].ToString()) { 
            case "STOCK_CAT": 
                Cmd = new OleDbCommand("SELECT COUNT(CategoryID) FROM ProductCategories WHERE CategoryID=?", Conn); 
                Cmd.Parameters.Add(new OleDbParameter("@CategoryID", Request.Form["NUMBER"])).DbType = DbType.Int32; 
                
                if (Convert.ToInt32(Cmd.ExecuteScalar()) > 0) { 
                    Cmd.CommandText = "UPDATE ProductCategories SET CategoryName=? WHERE CategoryID=?"; 
                } 
                else { 
                    Cmd.CommandText = "INSERT INTO ProductCategories (CategoryName, CategoryID) VALUES (?, ?)"; 
                } 

                
                Cmd.Parameters.Clear(); 
                Cmd.Parameters.Add(new OleDbParameter("@CategoryName", Request.Form["NAME"])).DbType = DbType.String; 
                Cmd.Parameters.Add(new OleDbParameter("@CategoryID", Request.Form["NUMBER"])).DbType = DbType.Int32; 
                
                try { 
                    Cmd.ExecuteNonQuery(); 
                } 
                catch (Exception ex) { 
                    Conn.Close(); 
                    throw ex; 
                } 

                break; 
            
            case "STOCK":                
                Cmd = new OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn); 
                Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Request.Form["STOCK_CODE"])).DbType = DbType.String; 
                
                if (Convert.ToInt32(Cmd.ExecuteScalar()) > 0) { 
                    Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?"; 
                } 
                else { 
                    Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES (?, ?, ?, ?)"; 
                } 

                
                Cmd.Parameters.Clear(); 
                Cmd.Parameters.Add(new OleDbParameter("@Description", Request.Form["DESCRIPTION"])).DbType = DbType.String; 
                Cmd.Parameters.Add(new OleDbParameter("@SalesPrice", Request.Form["SALES_PRICE"])).DbType = DbType.Double; 
                Cmd.Parameters.Add(new OleDbParameter("@Category", Request.Form["STOCK_CAT"])).DbType = DbType.Int32; 
                Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Request.Form["STOCK_CODE"])).DbType = DbType.String; 
                
                try { 
                    Cmd.ExecuteNonQuery(); 
                } 
                catch (Exception ex) { 
                    Conn.Close(); 
                    throw ex; 
                } 

                break; 
        
        } 
        
        Conn.Close(); 
    } 
    
    
} 
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<title></title>
</head>
<body>
</body>
</html>
