﻿<%@ Page Language="C#" %>

<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">

    protected void Page_Load(object sender, System.EventArgs e)
    {

        if (Request.Form["SageTable"] != null && Request.Form["SageTable"].ToString() == "STOCK")
        {

            OleDbConnectionStringBuilder ConStrBuilder = new OleDbConnectionStringBuilder();
            ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb");
            ConStrBuilder.PersistSecurityInfo = false;

            OleDbConnection Conn = new OleDbConnection(ConStrBuilder.ConnectionString);

            Conn.Open();

            OleDbCommand Cmd = new OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn);
            Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Request.Form["STOCK_CODE"])).DbType = DbType.String;

            bool RecordExists = Convert.ToInt32(Cmd.ExecuteScalar()) > 0;

            if (RecordExists)
            {
                Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?";
            }
            else
            {
                Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES(?, ?, ?, ?)";
            }

            Cmd.Parameters.Clear();
            Cmd.Parameters.Add(new OleDbParameter("@Description", Request.Form["DESCRIPTION"])).DbType = DbType.String;
            Cmd.Parameters.Add(new OleDbParameter("@SalesPrice", Request.Form["SALES_PRICE"])).DbType = DbType.Double;
            Cmd.Parameters.Add(new OleDbParameter("@Category", Request.Form["STOCK_CAT"])).DbType = DbType.String;
            Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Request.Form["STOCK_CODE"])).DbType = DbType.String;

            //Execute Insert/Update 
            try
            {
                Cmd.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                Conn.Close();
            }
        }


    } 

</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
</body>
</html>
