﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">

    protected void Page_Load(object sender, System.EventArgs e)
    {
        if (Request.Form["PostMode"] != null)
        {

            OleDbConnectionStringBuilder ConStrBuilder = new OleDbConnectionStringBuilder();
            ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb");
            ConStrBuilder.PersistSecurityInfo = false;

            OleDbConnection Conn = new OleDbConnection(ConStrBuilder.ConnectionString);

            Conn.Open();


            string[] TableNames = Request.Form["TableNames"].ToString().Split(',');
            foreach (string TableName in TableNames)
            {
                HtmlGenericControl FieldSet = new HtmlGenericControl("fieldset");
                this.Form1.Controls.Add(FieldSet);
                this.Form1.Controls.Add(new LiteralControl("<br />"));
                FieldSet.Controls.Add(new LiteralControl("<legend>" + TableName + "</legend>"));

                DataTable Tbl = new DataTable(TableName);
                Tbl.Columns.Add("Action");

                string[] ColumnNames = Request.Form[TableName + "_ColumnNames"].ToString().Split(',');
                foreach (string ColumnName in ColumnNames)
                {
                    Tbl.Columns.Add(ColumnName);
                }

                int RecordCount = Convert.ToInt32(Request.Form[TableName + "_RecordCount"]);

                for (int i = 0; i <= RecordCount - 1; i++)
                {
                    DataRow Dr = Tbl.NewRow();
                    foreach (string ColumnName in ColumnNames)
                    {
                        Dr[ColumnName] = Request.Form[TableName + "_" + ColumnName + "_" + i];
                    }
                    Tbl.Rows.Add(Dr);

                    bool IsInsert = false;

                    OleDbCommand Cmd;

                    switch (TableName)
                    {
                        case "STOCK_CAT":
                            Cmd = new OleDbCommand("SELECT COUNT(CategoryID) FROM ProductCategories WHERE CategoryID=?", Conn);
                            Cmd.Parameters.Add(new OleDbParameter("@CategoryID", Dr["NUMBER"])).DbType = DbType.Int32;

                            if (Convert.ToInt32(Cmd.ExecuteScalar()) > 0)
                            {
                                IsInsert = false;
                                Cmd.CommandText = "UPDATE ProductCategories SET CategoryName=? WHERE CategoryID=?";
                            }
                            else
                            {
                                IsInsert = true;
                                Cmd.CommandText = "INSERT INTO ProductCategories (CategoryName, CategoryID) VALUES (?, ?)";
                            }


                            Cmd.Parameters.Clear();
                            Cmd.Parameters.Add(new OleDbParameter("@CategoryName", Dr["NAME"])).DbType = DbType.String;
                            Cmd.Parameters.Add(new OleDbParameter("@CategoryID", Dr["NUMBER"])).DbType = DbType.Int32;

                            try
                            {
                                Cmd.ExecuteNonQuery();
                                Dr["Action"] = (IsInsert ? "Inserted" : "Updated");
                            }
                            catch
                            {
                                Dr["Action"] = (IsInsert ? "Insert Failed" : "Update Failed");
                            }

                            break;

                        case "STOCK":

                            Cmd = new OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn);
                            Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Dr["STOCK_CODE"])).DbType = DbType.String;

                            if (Convert.ToInt32(Cmd.ExecuteScalar()) > 0)
                            {
                                IsInsert = false;
                                Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?";
                            }
                            else
                            {
                                IsInsert = true;
                                Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES (?, ?, ?, ?)";
                            }


                            Cmd.Parameters.Clear();
                            Cmd.Parameters.Add(new OleDbParameter("@Description", Dr["DESCRIPTION"])).DbType = DbType.String;
                            Cmd.Parameters.Add(new OleDbParameter("@SalesPrice", Dr["SALES_PRICE"])).DbType = DbType.Double;
                            Cmd.Parameters.Add(new OleDbParameter("@Category", Dr["STOCK_CAT"])).DbType = DbType.Int32;
                            Cmd.Parameters.Add(new OleDbParameter("@ProductCode", Dr["STOCK_CODE"])).DbType = DbType.String;

                            try
                            {
                                Cmd.ExecuteNonQuery();
                                Dr["Action"] = (IsInsert ? "Inserted" : "Updated");
                            }
                            catch
                            {
                                Dr["Action"] = (IsInsert ? "Insert Failed" : "Update Failed");
                            }

                            break;

                    }
                }



                System.Web.UI.WebControls.GridView Dg = new System.Web.UI.WebControls.GridView();
                Dg.BorderWidth = 0;
                Dg.CellPadding = 3;
                Dg.HeaderStyle.Font.Name = "arial";
                Dg.HeaderStyle.Font.Size = 8;
                FieldSet.Controls.Add(Dg);
                Dg.DataSource = Tbl.DefaultView;
                Dg.DataBind();
            }


            Conn.Close();
        }


    } 

    
</script>

<html>
<head>
    <title></title>
    <style>
        body
        {
            font-family: Arial;
            font-size: 8pt;
        }
        td
        {
            font-family: Arial;
            font-size: 8pt;
        }
    </style>
</head>
<body>
<p>The Following Actions Were Taken:</p>
    <form id="Form1" runat="server">
    </form>
</body>
</html>
