﻿<%@ Page Language="VB" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        
        Dim ExportErrors As New DataSet("ExportErrors")
        Dim TblErrors As DataTable = ExportErrors.Tables.Add("ErrorLogs")
        
        Dim Col As DataColumn
        Col = TblErrors.Columns.Add("ErrorID", GetType(Int32))
        Col.AutoIncrement = True
        Col.AutoIncrementSeed = 1
        Col.AutoIncrementStep = 1
        
        Col = TblErrors.Columns.Add("IsHtml", GetType(Boolean))
        Col.DefaultValue = False
        
        TblErrors.Columns.Add("ErrorTitle", GetType(String))
        TblErrors.Columns.Add("ErrorMessage", GetType(String))
        TblErrors.Columns.Add("ExportData", GetType(String))
        TblErrors.Columns.Add("StackTrace", GetType(String))
       
        If Request.Files.Count > 0 Then
            
    

            Dim Ds As New DataSet
            Ds.ReadXml(Request.Files(0).InputStream)
                
            Dim ConStrBuilder As New OleDbConnectionStringBuilder()
            ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0"
            ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb")
            ConStrBuilder.PersistSecurityInfo = False

            Dim Conn As New OleDbConnection(ConStrBuilder.ConnectionString)

            Conn.Open()
                
            For Each Row As DataRow In Ds.Tables("STOCK").Rows
                Dim IsInsert As Boolean
                   
                Dim Cmd As New OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn)
                Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Row("STOCK_CODE"))).DbType = DbType.String

                Dim RecordExists As Boolean = Convert.ToInt32(Cmd.ExecuteScalar()) > 0

                    
                If RecordExists Then
                    IsInsert = False
                    Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?"
                Else
                    IsInsert = True
                    Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES(?, ?, ?, ?)"
                End If
                    
                Cmd.Parameters.Clear()

                Try
                    Cmd.Parameters.Add(New OleDbParameter("@Description", Row("DESCRIPTION"))).DbType = DbType.String
                    Cmd.Parameters.Add(New OleDbParameter("@SalesPrice", Row("SALES_PRICE"))).DbType = DbType.Double
                    Cmd.Parameters.Add(New OleDbParameter("@Category", Row("STOCK_CAT"))).DbType = DbType.String
                    Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Row("STOCK_CODE"))).DbType = DbType.String
                    Cmd.ExecuteNonQuery()
                Catch ex As Exception
                    Dim NewErrorRow As DataRow = TblErrors.NewRow
                    NewErrorRow("ErrorTitle") = IIf(IsInsert, "Insert Record Failed", "Update Record Failed")
                    NewErrorRow("ErrorMessage") = ex.Message
                    NewErrorRow("StackTrace") = ex.StackTrace
                    NewErrorRow("ExportData") = ""
                    For Each Column As DataColumn In Row.Table.Columns
                        NewErrorRow("ExportData") &= Column.ColumnName & "=" & Row(Column.ColumnName) & vbCrLf
                    Next
                    TblErrors.Rows.Add(NewErrorRow)
                End Try
                                      
            Next
                
    
            Conn.Close()
                
        End If
      
        Response.Clear()
        Response.Write("<?xml version=""1.0"" standalone=""yes""?>" & vbCrLf & ExportErrors.GetXml())
        Response.End()
        
    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<title></title>
</head>
<body>
</body>
</html>
