﻿<%@ Page Language="VB" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        If Request.Form("PostMode") IsNot Nothing Then
            
            
            Dim ConStrBuilder As New OleDbConnectionStringBuilder()
            ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0"
            ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb")
            ConStrBuilder.PersistSecurityInfo = False
     
            Dim Conn As New OleDbConnection(ConStrBuilder.ConnectionString)
            
            Conn.Open()
            
            
            Dim TableNames() As String = Request.Form("TableNames").ToString().Split(",")
            For Each TableName As String In TableNames
                Dim FieldSet As New HtmlGenericControl("fieldset")
                Me.Form1.Controls.Add(FieldSet)
                Me.Form1.Controls.Add(New LiteralControl("<br />"))
                FieldSet.Controls.Add(New LiteralControl("<legend>" & TableName & "</legend>"))
                
                Dim Tbl As New DataTable(TableName)
                Tbl.Columns.Add("Action")
                
                Dim ColumnNames() As String = Request.Form(TableName & "_ColumnNames").ToString().Split(",")
                For Each ColumnName As String In ColumnNames
                    Tbl.Columns.Add(ColumnName)
                Next
                
                Dim RecordCount As Integer = Convert.ToInt32(Request.Form(TableName & "_RecordCount"))
                
                For i As Integer = 0 To RecordCount - 1
                    Dim Dr As DataRow = Tbl.NewRow
                    For Each ColumnName As String In ColumnNames
                        Dr(ColumnName) = Request.Form(TableName & "_" & ColumnName & "_" & i)
                    Next
                    Tbl.Rows.Add(Dr)
                    
                    Dim IsInsert As Boolean
                    
                    Select Case TableName
                        Case "STOCK_CAT"
                            Dim Cmd As New OleDbCommand("SELECT COUNT(CategoryID) FROM ProductCategories WHERE CategoryID=?", Conn)
                            Cmd.Parameters.Add(New OleDbParameter("@CategoryID", Dr("NUMBER"))).DbType = DbType.Int32
            
                            If Convert.ToInt32(Cmd.ExecuteScalar()) > 0 Then
                                IsInsert = False
                                Cmd.CommandText = "UPDATE ProductCategories SET CategoryName=? WHERE CategoryID=?"
                            Else
                                IsInsert = True
                                Cmd.CommandText = "INSERT INTO ProductCategories (CategoryName, CategoryID) VALUES (?, ?)"
                            End If
                
                            Cmd.Parameters.Clear()
                            Cmd.Parameters.Add(New OleDbParameter("@CategoryName", Dr("NAME"))).DbType = DbType.String
                            Cmd.Parameters.Add(New OleDbParameter("@CategoryID", Dr("NUMBER"))).DbType = DbType.Int32
                
                            Try
                                Cmd.ExecuteNonQuery()
                                Dr("Action") = IIf(IsInsert, "Inserted", "Updated")
                            Catch ex As Exception
                                Dr("Action") = IIf(IsInsert, "Insert Failed", "Update Failed")
                            End Try
                    
                        Case "STOCK"
   
                            Dim Cmd As New OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn)
                            Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Dr("STOCK_CODE"))).DbType = DbType.String

                            If Convert.ToInt32(Cmd.ExecuteScalar()) > 0 Then
                                IsInsert = False
                                Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?"
                            Else
                                IsInsert = True
                                Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES (?, ?, ?, ?)"
                            End If

                            Cmd.Parameters.Clear()
                            Cmd.Parameters.Add(New OleDbParameter("@Description", Dr("DESCRIPTION"))).DbType = DbType.String
                            Cmd.Parameters.Add(New OleDbParameter("@SalesPrice", Dr("SALES_PRICE"))).DbType = DbType.Double
                            Cmd.Parameters.Add(New OleDbParameter("@Category", Dr("STOCK_CAT"))).DbType = DbType.Int32
                            Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Dr("STOCK_CODE"))).DbType = DbType.String
                
                            Try
                                Cmd.ExecuteNonQuery()
                                Dr("Action") = IIf(IsInsert, "Inserted", "Updated")
                            Catch ex As Exception
                                Dr("Action") = IIf(IsInsert, "Insert Failed", "Update Failed")
                            End Try
                    
                    End Select
                    
                    
                Next
                
                Dim Dg As New System.Web.UI.WebControls.GridView
                Dg.BorderWidth = 0
                Dg.CellPadding = 3
                Dg.HeaderStyle.Font.Name = "arial"
                Dg.HeaderStyle.Font.Size = 8
                FieldSet.Controls.Add(Dg)
                Dg.DataSource = Tbl.DefaultView
                Dg.DataBind()
                
            Next
            
            Conn.Close()
            
            
        End If
    End Sub
    
</script>

<html>
<head>
    <title></title>
    <style>
        body
        {
            font-family: Arial;
            font-size: 8pt;
        }
        td
        {
            font-family: Arial;
            font-size: 8pt;
        }
    </style>
</head>
<body>
<p>The Following Actions Were Taken:</p>
    <form id="Form1" runat="server">
    </form>
</body>
</html>
