﻿<%@ Page Language="VB" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>

<script runat="server">
   
    
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        If Request.Files.Count > 0 Then

            Dim Ds As New DataSet
            Ds.ReadXml(Request.Files(0).InputStream)

            Dim ConStrBuilder As New OleDbConnectionStringBuilder()
            ConStrBuilder.Provider = "Microsoft.Jet.OLEDB.4.0"
            ConStrBuilder.DataSource = Path.Combine(Request.PhysicalApplicationPath, "DemoData.mdb")
            ConStrBuilder.PersistSecurityInfo = False

            Dim Conn As New OleDbConnection(ConStrBuilder.ConnectionString)

            Conn.Open()

            For Each Row As DataRow In Ds.Tables("STOCK_CAT").Rows

                Dim Cmd As New OleDbCommand("SELECT COUNT(CategoryID) FROM ProductCategories WHERE CategoryID=?", Conn)
                Cmd.Parameters.Add(New OleDbParameter("@CategoryID", Row("NUMBER"))).DbType = DbType.Int32
               
                
                If Convert.ToInt32(Cmd.ExecuteScalar()) > 0 Then
                    Cmd.CommandText = "UPDATE ProductCategories SET CategoryName=? WHERE CategoryID=?"
                Else
                    Cmd.CommandText = "INSERT INTO ProductCategories (CategoryName, CategoryID) VALUES (?, ?)"
                End If
                
                Cmd.Parameters.Clear()
                Cmd.Parameters.Add(New OleDbParameter("@CategoryName", Row("NAME"))).DbType = DbType.String
                Cmd.Parameters.Add(New OleDbParameter("@CategoryID", Row("NUMBER"))).DbType = DbType.Int32
                
                Try
                    Cmd.ExecuteNonQuery()
                Catch ex As Exception
                    Conn.Close()
                    Throw ex
                End Try

            Next

            For Each Row As DataRow In Ds.Tables("STOCK").Rows

                Dim Cmd As New OleDbCommand("SELECT COUNT(ProductCode) FROM Products WHERE ProductCode=?", Conn)
                Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Row("STOCK_CODE"))).DbType = DbType.String

                If Convert.ToInt32(Cmd.ExecuteScalar()) > 0 Then
                    Cmd.CommandText = "UPDATE Products SET Description=?, SalesPrice=?, Category=? WHERE ProductCode=?"
                Else
                    Cmd.CommandText = "INSERT INTO Products (Description, SalesPrice, Category, ProductCode) VALUES (?, ?, ?, ?)"
                End If

                Cmd.Parameters.Clear()
                Cmd.Parameters.Add(New OleDbParameter("@Description", Row("DESCRIPTION"))).DbType = DbType.String
                Cmd.Parameters.Add(New OleDbParameter("@SalesPrice", Row("SALES_PRICE"))).DbType = DbType.Double
                Cmd.Parameters.Add(New OleDbParameter("@Category", Row("STOCK_CAT"))).DbType = DbType.Int32
                Cmd.Parameters.Add(New OleDbParameter("@ProductCode", Row("STOCK_CODE"))).DbType = DbType.String
                
                Try
                    Cmd.ExecuteNonQuery()
                Catch ex As Exception
                    Conn.Close()
                    Throw ex
                End Try

            Next

            Conn.Close()

        End If

    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<title></title>
</head>
<body>
</body>
</html>
